/*
 * This file is part of GtkJson.
 *
 * Copyright © 2023 Canek Peláez Valdés
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

namespace GtkJson.Application {

    /**
     * Class for running a GtkJson application.
     */
    public class ApplicationMain {

        /**
         * Entry point of the program.
         */
        public static int main(string[] args) {
            GLib.assert(typeof(string) != typeof(NodeRow));
            GLib.Environment.set_application_name("GtkJson");
            try {
                var context = "GtkJson";
                var opt = new GLib.OptionContext(context);
                opt.set_help_enabled(true);
                opt.parse(ref args);
            } catch (GLib.Error e) {
                GLib.error(@"Error parsing options: $(e.message)");
            }

            var gtkjson = new Application();
            return gtkjson.run(args);
        }
    }
}
